﻿if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Lang' ) and Type='U')
	Drop table dbo.A_Lang
GO

-------------------------------------------------------

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_GroupOperators' ) and Type='V')
	Drop View dbo.C_GroupOperators
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.C_GroupOperators' ) and Type='U')
	Drop table oktell_settings.dbo.C_GroupOperators
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_Groups' ) and Type='V')
	Drop View dbo.C_Groups
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.C_Groups' ) and Type='U')
	Drop table oktell_settings.dbo.C_Groups
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_Group_Delete' ))	
	Drop procedure dbo.C_Group_Delete
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_Group_Save' ))	
	Drop procedure dbo.C_Group_Save
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_CallCenter_GetTaskPercentsTableForIdGroupUser' ))	
	Drop procedure dbo.C_CallCenter_GetTaskPercentsTableForIdGroupUser
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.D_Get_Task_Abonents_Stat' ))	
	Drop procedure dbo.D_Get_Task_Abonents_Stat
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_GroupOperator_DeleteFromGroups_ByOperatorId' ))	
	Drop procedure dbo.C_GroupOperator_DeleteFromGroups_ByOperatorId
GO

Create procedure dbo.C_GroupOperator_DeleteFromGroups_ByOperatorId
	@id uniqueidentifier
as
Begin
	--obsolete
	Declare @x int
End
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_GroupOperator_Save' ))	
	Drop procedure dbo.C_GroupOperator_Save
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_CallCenter_GetOperatorJournal' ))	
	Drop procedure dbo.C_CallCenter_GetOperatorJournal
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_GroupsOperators_GetAll' ))	
	Drop procedure dbo.C_GroupsOperators_GetAll
GO

Create Procedure [dbo].[C_GroupsOperators_GetAll]
As
begin
	-- obsolete
	
	Select u.id as uid, u.name as uname, NULL as gid, NULL as gcaption
	From
		A_Users u inner join 
		A_UserParams up on u.id = up.iduser
	Where ( up.IsOperator > 0 ) and 
		(( u.IsDeleted = 0 ) or ( u.IsDeleted is null ))
		
end
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_GetAllOperators' ))	
	Drop procedure dbo.A_CallCenter_GetAllOperators
GO

Create Procedure [dbo].[A_CallCenter_GetAllOperators]
As
begin
	-- obsolete
	
	Select u.id as uid, u.name as uname, NULL as gid, NULL as gcaption
	From
		A_Users u inner join 
		A_UserParams up on u.id = up.iduser
	Where ( up.IsOperator > 0 ) and 
		(( u.IsDeleted = 0 ) or ( u.IsDeleted is null ))
		
end
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_TaskControlEvents' ) and Type='V')
	Drop View dbo.C_TaskControlEvents
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.C_TaskControlEvents' ) and Type='U')
	Drop table oktell_settings.dbo.C_TaskControlEvents
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_TaskControlEvent_DeleteByTask' ))	
	Drop procedure dbo.C_TaskControlEvent_DeleteByTask
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_TaskControlEvent_GetAll' ))	
	Drop procedure dbo.C_TaskControlEvent_GetAll
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_TaskControlEvent_GetAllForTask' ))	
	Drop procedure dbo.C_TaskControlEvent_GetAllForTask
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_TaskControlEvent_Save' ))	
	Drop procedure dbo.C_TaskControlEvent_Save
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_OperatorControlEvents' ) and Type='V')
	Drop View dbo.C_OperatorControlEvents
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.C_OperatorControlEvents' ) and Type='U')
	Drop table oktell_settings.dbo.C_OperatorControlEvents
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_GroupOperatorControlEvent_Save' ))	
	Drop procedure dbo.C_GroupOperatorControlEvent_Save
GO	

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_OperatorControlEvents_GetAll' ))	
	Drop procedure dbo.C_OperatorControlEvents_GetAll
GO	

Create procedure dbo.C_OperatorControlEvents_GetAll
as
Begin
	--obsolete
	Declare @x int
End
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.C_GroupOperatorControlEvent_DeleteByOperator' ))	
	Drop procedure dbo.C_GroupOperatorControlEvent_DeleteByOperator
GO	

Create procedure dbo.C_GroupOperatorControlEvent_DeleteByOperator
	@id uniqueidentifier
as
Begin
	--obsolete
	Declare @x int
End
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A__Extra_OneLine_Settings' ) and Type='V')
	Drop View dbo.A__Extra_OneLine_Settings
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A__Extra_OneLine_Settings' ) and Type='U')
	Drop table oktell_settings.dbo.A__Extra_OneLine_Settings
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_ActualBase' ) and Type='V')
	Drop View dbo.A_ActualBase
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ActualBase' ) and Type='U')
	Drop table oktell_settings.dbo.A_ActualBase
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_Extra_SaveRestoreAdmin' ))
	Drop procedure dbo.A_DB_Extra_SaveRestoreAdmin
GO

Create Procedure [dbo].[A_DB_Extra_SaveRestoreAdmin]
as
begin
-- Зачаток процедуры сохранения данных перед полной очисткой

	exec dbo.A_DB_FREEALL

	Insert Into A_Users 
		Select * From A_users 
	Insert Into A_WorkPlaces
		Select * From A_workplaces 
	Insert Into A_Groups
		Select * From A_groups 
	Insert Into A_NumberPlan
		Select * From A_numberplan 
	Insert Into A_NumberPlanAction
		Select * From A_numberplanaction
	Insert Into A_Rules
		Select * From A_rules 
	Insert Into A_RuleRecords
		Select * From A_RuleRecords 
	Insert Into A_Settings
		Select * From A_Settings 
	Insert Into A_WorkPlace_Address
		Select * From A_Workplace_Address
	Insert Into A_ServerUSBLines
		Select * From A_ServerUsbLines 
	Insert Into A_ServerIntLines
		Select * From A_ServerIntLines 
	Insert Into A_ServerSipLines
		Select * From A_ServerSipLines 
	Insert Into A_ServerVirtualLines
		Select * From A_ServerVirtualLines 
	Insert Into A_ServerExtLines
		Select * From A_ServerExtLines 
	Insert Into A_ServerNumbers
		Select * From A_ServerNumbers

end
GO
-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_ExtNumbers' ) and Type='V')
	Drop View dbo.A_ExtNumbers
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ExtNumbers' ) and Type='U')
	Drop table oktell_settings.dbo.A_ExtNumbers
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_RemoveTails' ))
	Drop procedure dbo.A_DB_RemoveTails
GO

Create Procedure [dbo].[A_DB_RemoveTails] 
as
begin

-- Отрубание глюков после изменений в БД. Лишние ссылки, пустые элементы и т.д.

		-----------------------------------------------------
		-- преобразования на стыке версий -------------------
		-----------------------------------------------------

		Update dbo.A_ServerExtLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerGSMLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerIntLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerSipLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerUSBLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerVirtualLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		-----------------------------------------------------
		-- общие возможные глюки ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		Delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		Delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )

		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WorkPlaces Union 
			Select [id] From A_Users union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		--записи правил, где пользователь или линия несуществующие
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		--записи правил, где поток несуществующий
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		Delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		Delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		Delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users u inner join A_UserParams up on u.Id = up.IdUser Where up.IsOperator = 1 )
		Delete From A_TaskManager_TaskProperties where not IdTask in ( Select id From A_TaskManager_Tasks )
		Delete From A_TaskManager_Lists Where (ProjectId = '00000000-0000-0000-0000-000000000000') and not exists ( Select Id From A_TaskManager_Tasks t where t.ListId = A_TaskManager_Lists.Id )
		Delete From A_TaskManager_Tasks Where (IdProject = '00000000-0000-0000-0000-000000000000') and not exists ( Select Id From A_TaskManager_Lists t where t.Id = A_TaskManager_Tasks.ListId )

		-----------------------------------------------------
		-- сетевые адреса рабочих мест = адресу сервера - заменяем брехней 
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = 'Ошибка в адресе' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null в 0 в ID юзеров по умолчанию ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		-- в 0 несуществующих юзеров по умолчанию -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		-- двоение юзеров по умолчанию в ссылках по линиям --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		-- удаляем несуществующие значения ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 0 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Delete 
		From A_UserControls
		Where not exists (Select id From A_Users u Where u.id = A_UserControls.UserA)
			or not exists (Select id From A_Users u Where u.id = A_UserControls.UserB)
			
		Delete 		
		From A_UserControlLines
		Where not exists (Select id From A_Users u Where u.id = A_UserControlLines.UserA)			
			or (not exists (Select id From A_Users l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_ServerIntLines l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_ServerSipLines l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_ServerExtLines l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_CallRoutes l Where l.id = A_UserControlLines.IdLine)				
				and (A_UserControlLines.IdLine != '11111111-1111-1111-1111-111111111111')
				and (A_UserControlLines.IdLine != '6F5F7372-D82E-4FB6-97CB-85487A85067C')
				and (A_UserControlLines.IdLine != '14B559C8-BDF8-4D17-9968-FEB8F9F54F47'))				
				
		Delete
		From A_UserOutcomingLines
		Where not exists (Select id From A_Users u Where u.id = A_UserOutcomingLines.IdUser)
			and not exists (Select id From A_ServerExtLines l Where l.id = A_UserOutcomingLines.IdLine)
				
		-----------------------------------------------------
		-- Роли на удаленных юзеров -------------------------
		-----------------------------------------------------
		
		Delete From A_UserRoles_Roles
		Where (Domination = 1)
			and ( not Id in (Select id From A_Users))
			
		Delete
		From A_UserRoles_RolesOfUsers
		Where not IdUser in (Select Id From A_Users)
	
		Delete
		From A_UserRoles_RolesOfUsers
		Where not IdRole in (Select Id From A_UserRoles_Roles)
		
		Delete
		From A_UserRoles_RightsOfRoles
		Where not IdRole in (Select Id From A_UserRoles_Roles)

		-----------------------------------------------------
		-- Редиректы на удаленных юзеров --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		-- Пустые группы, номера, несвязанные правила -------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		exec A_Admin_Number_SiftByActions
		
		exec A_Admin_Rule_SiftByNumbers
		
		-----------------------------------------------------
		-- неиспользуемые плагин-модули ---------------------
		-----------------------------------------------------
		Delete From A_PluginMenu_User
		Where not exists ( Select Id From A_Users u Where u.Id = A_PluginMenu_User.IdUser )

		-----------------------------------------------------
		-- канонические адреса ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address
		
		-----------------------------------------------------	
		-- Очистка пустых ссылок в таблицах политики прав доступа к объектам
		-----------------------------------------------------	
		exec dbo.A_Policy_CheckFilter
end
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_LineCodes' ) and Type='V')
	Drop View dbo.A_LineCodes
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_LineCodes' ) and Type='U')
	Drop table oktell_settings.dbo.A_LineCodes
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Policy_Subjects' ) and Type='V')
	Drop View dbo.A_Policy_Subjects
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_Subjects' ) and Type='U')
	Drop table oktell_settings.dbo.A_Policy_Subjects
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserPermissions' ) and Type='V')
	Drop View dbo.A_UserPermissions
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_UserPermissions' ) and Type='U')
	Drop table oktell_settings.dbo.A_UserPermissions
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserPermissionsLines' ) and Type='V')
	Drop View dbo.A_UserPermissionsLines
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_UserPermissionsLines' ) and Type='U')
	Drop table oktell_settings.dbo.A_UserPermissionsLines
GO

-------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserRights' ) and Type='V')
	Drop View dbo.A_UserRights
GO

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_UserRights' ) and Type='U')
	Drop table oktell_settings.dbo.A_UserRights
GO
 
------------------------------------------------------------

if not exists ( Select * from sysobjects where id = object_id ( 'dbo.A_MonopolyForTaskChanging' ))	
	CREATE TABLE [dbo].[A_MonopolyForTaskChanging](
		[Id] [uniqueidentifier] NOT NULL PRIMARY KEY,
		[IdUser] [uniqueidentifier] NULL,
		[IdTask] [uniqueidentifier] NULL,
		[TakenDateTime] [datetime] NULL,
		[Val] [int] NULL 
	) ON [PRIMARY]
	GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_InitOnStart' ))
	Drop procedure dbo.A_DB_InitOnStart
GO

Create procedure [dbo].[A_DB_InitOnStart]
As
begin
		-- On PBXStatusServer start (2)

		-----------------------------------------------------
		-- Проставляем отвалившихся пользователей -----------
		-----------------------------------------------------
		
		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		Declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory --with ( UpdLock )

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0, 10104 --'Отвалился'
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task - проставляем в нуллы значения
		-----------------------------------------------------

		Update A_TaskManager_UserInTask with ( TabLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null )

		-----------------------------------------------------
		-- избавление от нуллов в таблице статусов операторов коллцентра, если сервак вырубили
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory with ( TabLock )
		Set TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		-- очищаем монополии
		-----------------------------------------------------
		
		Delete From A_Monopoly
		Delete From A_MonopolyForTaskChanging
		Delete From C_MonopolyForTaskChanging /*obsolete*/

		-----------------------------------------------------
		-- Пустые входящие задачи, необработанные - ексепшны и положенные трубы
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		-- неиспользуемые таблицы локальных списков
		-----------------------------------------------------

		Declare @llid int
		Declare @llname nvarchar ( 1000 )
		Declare @ltid uniqueidentifier
		Declare @ltids nvarchar ( 50 )
		Declare @sql nvarchar ( 500 )
		
		Declare tcursor Cursor For
			Select name, Id  
			From sysobjects 
			Where ([type] = 'U') 
				and (name like 'A_TaskManager_LocalList%')
		
		Open tcursor
		Fetch Next From tcursor 
					Into @llname, @llid

		While (@@FETCH_STATUS = 0) begin
		
			Set @llname = 'dbo.[' + @llname + ']'

			-- по названиям (id в названии и Id списка совпадают) (недостаточно в связи с переменой имен - может много быть таблиц с одним ид. N-1 надо удалить)	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			-- по явным ссылкам через поле JoinedTable в списках
			If not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname ) begin
				set @sql = ' DROP TABLE ' + @llname
				exec sp_executesql @stmt = @sql
			end

			Fetch Next From tcursor 
						Into @llname, @llid
		end

		Close tcursor
		Deallocate tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		-- таблицы КЦ создать??
		--надо или нет обнулить счетчики текущих состояний для куба состояний?
		-- и саму таблицу тоже закрыть?
		-- вроде надо бы.. ничего не мешает, а от возможных глюков избавит..
		Exec dbo.A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
end
GO

if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_DB_UserLogoff' ))
	Drop procedure dbo.A_DB_UserLogoff
GO

Create PROCEDURE [dbo].[A_DB_UserLogoff] 
	@iduser uniqueidentifier
AS
begin

		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'


		-----------------------------------------------------
		-- Monopoly очищаем все забитые под юзером
		-----------------------------------------------------		
		delete from A_MonopolyForTaskChanging where IdUser = @iduser
		delete from C_MonopolyForTaskChanging where IdUser = @iduser /*obsolete*/		

		-----------------------------------------------------
		-- Таблица состояний оператора в колл-центре
		-----------------------------------------------------
		exec A_CallCenter_UserStateChange @start = 0, @idoperator = @iduser, @state = 0, @info = '', @selfinfo = 0

		-----------------------------------------------------
		-- User in Task - проставляем в нуллы значения
		-----------------------------------------------------
		Update A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( UserId = @iduser ) and
			(( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null ))
		/*
		-----------------------------------------------------
		-- в кубе состояний операторов - обнуляем все показатели для юзера
		-----------------------------------------------------		
		Declare @dtnow DateTime 
		Set @dtnow = GetDate ( )
			Update [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]
			Set 	p0 = 0, p1 = 0, p2 = 0, p3 = 0, p4 = 0, p5 = 0,
				LastDT = @dtnow
			Where Id = @iduser
		*/
end
GO	


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Task_FinishMonopolyForUser' ))
	Drop procedure dbo.A_Task_FinishMonopolyForUser
GO

Create Procedure [dbo].[A_Task_FinishMonopolyForUser]
	@id 	uniqueidentifier
as
begin
	delete from A_MonopolyForTaskChanging where IdUser = @id
end
GO


if exists ( Select * from sysobjects where id=object_id ( 'dbo.A_Task_TrySetMonopolyForUser' ))
	Drop procedure dbo.A_Task_TrySetMonopolyForUser
GO

Create Procedure [dbo].[A_Task_TrySetMonopolyForUser]
	@userid 	uniqueidentifier,
	@taskid		uniqueidentifier,
	@set		int,
	@dt		datetime,
	@succeed	int	OUTPUT,
	@usermonopolying uniqueidentifier	OUTPUT
as
begin
		
	set @succeed = 1
	set @usermonopolying = '00000000-0000-0000-0000-000000000000'

	if ( @set = 0 )
	begin
		Delete from A_MonopolyForTaskChanging where IdTask = @taskid and IdUser = @userid
	end
	else
	begin
		declare @id uniqueidentifier
		declare @v int
		declare @can int

		set @can = 1

		Select @usermonopolying = IdUser, @succeed = 0, @v = Val from A_MonopolyForTaskChanging where IdTask = @taskid
		if ( @@rowcount > 0 )
		begin
			if ( @usermonopolying != @userid )
				set @can = 0
			else
				delete from A_MonopolyForTaskChanging where IdTask = @taskid
		end

		if ( @can > 0 )
		begin
			set @id = newid()

			Insert into A_MonopolyForTaskChanging
				( id,  IdUser, IdTask, Val, TakenDateTime )
			Values 
				( @id, @userid, @taskid, 1, @dt )

			Select * FROM A_MonopolyForTaskChanging where IdTask = @taskid
			if ( @@rowcount > 1 )
			begin
				Delete from A_MonopolyForTaskChanging where IdTask = @taskid and IdUser = @userid
				Select @usermonopolying = IdUser, @succeed = 0 from A_MonopolyForTaskChanging where  IdTask = @taskid 
				Return;
			end
			else
			begin
				set @succeed = 1
				set @usermonopolying = '00000000-0000-0000-0000-000000000000'
				Return
			end
				
		end
		else
			Return;
		
		set @succeed = 0
		set @usermonopolying = '00000000-0000-0000-0000-000000000000'
	end

end
GO
