﻿if exists ( select * from sysobjects where id=object_id ( 'dbo.A_CallCenter_ControlEvents_GetJournal' ))
	Drop procedure dbo.A_CallCenter_ControlEvents_GetJournal
GO

Create procedure [dbo].[A_CallCenter_ControlEvents_GetJournal]
	@iduser uniqueidentifier,
	@datestart datetime,
	@datestop datetime,
	@timestart datetime,
	@timestop datetime,
	@idsevent nvarchar ( 4000 ) = '',
	@idstask nvarchar ( 4000 ) = '',
	@idstask1 nvarchar ( 4000 ) = '',
	@idstask2 nvarchar ( 4000 ) = '',
	@idstask3 nvarchar ( 4000 ) = '',
	@idstask4 nvarchar ( 4000 ) = '',
	@idstask5 nvarchar ( 4000 ) = '',
	@idsoperator nvarchar ( 4000 ) = '',
	@idsoperator1 nvarchar ( 4000 ) = '',
	@idsoperator2 nvarchar ( 4000 ) = '',
	@idsoperator3 nvarchar ( 4000 ) = '',
	@idsoperator4 nvarchar ( 4000 ) = '',
	@idsoperator5 nvarchar ( 4000 ) = '',
	@idsoperator6 nvarchar ( 4000 ) = '',
	@idsoperator7 nvarchar ( 4000 ) = '',
	@idsoperator8 nvarchar ( 4000 ) = '',
	@idsoperator9 nvarchar ( 4000 ) = '',
	@idsoperator10 nvarchar ( 4000 ) = '',
	@idsoperator11 nvarchar ( 4000 ) = '',
	@idsoperator12 nvarchar ( 4000 ) = '',
	@idsoperator13 nvarchar ( 4000 ) = '',
	@idsoperator14 nvarchar ( 4000 ) = '',
	@idsoperator15 nvarchar ( 4000 ) = '',
	@idsoperator16 nvarchar ( 4000 ) = '',
	@idsoperator17 nvarchar ( 4000 ) = '',
	@idsoperator18 nvarchar ( 4000 ) = '',
	@idsoperator19 nvarchar ( 4000 ) = ''
as
begin
	Declare @dstart datetime, @tstart datetime, @dstop datetime, @tstop datetime
	Set @dstart = Cast ( Floor ( Cast ( @datestart as float ) ) as DateTime )
	Set @dstop = Cast ( Floor ( Cast ( @datestop as float ) + 1 ) as DateTime )
	Set @tstart = Cast ( Cast ( @timestart as float ) - Floor ( Cast ( @timestart as float ) ) as DateTime )
	Set @tstop = Cast ( Cast ( @timestop as float ) - Floor ( Cast ( @timestop as float ) ) as DateTime )

	declare @temp nvarchar ( 4000 )
	declare @tempid uniqueidentifier
	declare @pidx int

	Declare @events table ( id uniqueidentifier )
	Declare @tasks table ( id uniqueidentifier )
	Declare @operators table ( id uniqueidentifier )

	set @temp = @idsevent
	if ( len ( @temp ) > 1 )
		while ( len ( @temp ) > 1 )
		begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @events values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end	
	else
		Insert into @events
			Select Id 
			From A_CallCenter_ControlEvents
			Where IsDeleted = 0

	set @temp = @idstask
	set @pidx = 0
	if ( len ( @temp ) > 1 )
	    while ( @pidx <= 5 ) begin
		while ( len ( @temp ) > 1 ) begin
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @tasks values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end
		
		set @pidx = @pidx + 1
		if ( @pidx > 5 )
			break;
		else 
			set @temp= case when ( @pidx = 1 ) then @idstask1 
					when ( @pidx = 2 ) then @idstask2
					when ( @pidx = 3 ) then @idstask3
					when ( @pidx = 4 ) then @idstask4
					when ( @pidx = 5 ) then @idstask5
					end
	    end

	else begin
		Insert into @tasks
			Select Id 
			From A_TaskManager_Tasks
		Insert into @tasks ( id ) values ( '00000000-0000-0000-0000-000000000000' )
   	end


	set @temp = @idsoperator
	set @pidx = 0
	if ( len ( @temp ) > 1 )
	    while ( @pidx <= 19 ) begin
		while ( len ( @temp ) > 1 ) begin
			--select Substring ( @temp, 1, 36 )
			set @tempid = cast ( Substring ( @temp, 1, 36 )	 as uniqueidentifier )
			insert into @operators values ( @tempid )
			set @temp = substring ( @temp, 38, len ( @temp ) - 37 )
		end

		set @pidx = @pidx + 1
		if ( @pidx > 10 )
			break
		else 
			set @temp= case when ( @pidx = 1 ) then @idsoperator1 
					when ( @pidx = 2 ) then @idsoperator2
					when ( @pidx = 3 ) then @idsoperator3
					when ( @pidx = 4 ) then @idsoperator4
					when ( @pidx = 5 ) then @idsoperator5
					when ( @pidx = 6 ) then @idsoperator6
					when ( @pidx = 7 ) then @idsoperator7
					when ( @pidx = 8 ) then @idsoperator8
					when ( @pidx = 9 ) then @idsoperator9
					when ( @pidx = 10 ) then @idsoperator10
					when ( @pidx = 11 ) then @idsoperator11 
					when ( @pidx = 12 ) then @idsoperator12
					when ( @pidx = 13 ) then @idsoperator13
					when ( @pidx = 14 ) then @idsoperator14
					when ( @pidx = 15 ) then @idsoperator15
					when ( @pidx = 16 ) then @idsoperator16
					when ( @pidx = 17 ) then @idsoperator17
					when ( @pidx = 18 ) then @idsoperator18
					when ( @pidx = 19 ) then @idsoperator19
					end
	    end

	else begin
		Insert into @operators
			Select Id 
			From A_Users
		Insert into @operators ( id ) values ( '00000000-0000-0000-0000-000000000000' )			
	end
	

	Select top 1000 j.Id, j.IdEvent, ce.Name as EventName, j.EventDateTime, j.ValStr, j.ValDec, j.IdTask, ti.Name as TaskName, j.IdOperator, oi.Name as OperatorName
	From A_CallCenter_ControlEventsJournal j
		Inner join A_CallCenter_ControlEvents ce on j.IdEvent = ce.Id
		Inner join @events e on j.IdEvent = e.Id
		Inner join @tasks t on j.IdTask = t.Id
		Inner join @operators o on j.IdOperator = o.Id
		Left join A_TaskManager_Tasks ti on ti.Id = t.Id
		Left join A_Users oi on oi.Id = o.Id
	Where (( EventDate >= @dstart ) and ( EventDate < @dstop ))	
		and (( EventTime > @tstart ) and ( EventTime < @tstop ))
	Order by EventDateTime Desc
end
GO
