﻿USE [oktell_settings]
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Websock_Config'))
	Drop table dbo.A_Websock_Config 
GO 

USE [oktell_settings]
CREATE TABLE dbo.A_Websock_Config 
(
 	[value] nVARCHAR(150)
)
GO     

USE [oktell_settings]
INSERT INTO dbo.A_Websock_Config VALUES ('w_favoritegetbyuser');
INSERT INTO dbo.A_Websock_Config VALUES ('w_favoritesavebyuser');
INSERT INTO dbo.A_Websock_Config VALUES ('w_favoritedeletebyuser');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clientsget');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clientgroupsget');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_mycalls_get');
INSERT INTO dbo.A_Websock_Config VALUES ('w_usernotifylog_gettypelist');
INSERT INTO dbo.A_Websock_Config VALUES ('w_usernotifylog_getbydate');
INSERT INTO dbo.A_Websock_Config VALUES ('w_usernotifylog_getnewcount');
INSERT INTO dbo.A_Websock_Config VALUES ('w_usernotifylog_getunshown');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_mycalls_relative');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_byinterval');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_summary');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_departments');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_departmentsummary');
INSERT INTO dbo.A_Websock_Config VALUES ('a_admin_usergroup_group_getall');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_usersummary');
INSERT INTO dbo.A_Websock_Config VALUES ('w_users_getnames');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_users');
INSERT INTO dbo.A_Websock_Config VALUES ('w_stat_getjournal');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_autocomplete');
INSERT INTO dbo.A_Websock_Config VALUES ('a_stat_comments_getcommentbyid');
INSERT INTO dbo.A_Websock_Config VALUES ('w_messages_getdialogs');
INSERT INTO dbo.A_Websock_Config VALUES ('w_messages_getuserswithnumbers');
INSERT INTO dbo.A_Websock_Config VALUES ('w_messages_getusers');
INSERT INTO dbo.A_Websock_Config VALUES ('w_messages_getnewcount');
INSERT INTO dbo.A_Websock_Config VALUES ('w_messages_getlastnbydate');
INSERT INTO dbo.A_Websock_Config VALUES ('w_messages_search');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_getcontacttypes');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_getinfofields');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_clientview');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_historyadd');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_historyedit');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_historydel');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_getbycontact');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_infotypeedit');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_infoedit');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_clientedit');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_contactadd');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_rightsset');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_rightsget');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_infotypegetall');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_contacttypesget');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_infoget');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_historyget');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_contactgetall');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_clientgetall');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_contactdelete');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_clientdelete');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_groupsget');
INSERT INTO dbo.A_Websock_Config VALUES ('w_clients_infodelete');
INSERT INTO dbo.A_Websock_Config VALUES ('w_callcenter_info_getoperatortasks');
INSERT INTO dbo.A_Websock_Config VALUES ('w_callcenter_info_getoperator');
GO

USE [oktell]
GO

USE [oktell]
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Websock_Config' ))
	Drop view dbo.A_Websock_Config
GO

Create view dbo.A_Websock_Config
as 
	Select * 
	FROM oktell_settings.dbo.A_Websock_Config
GO

IF OBJECT_ID('dbo.A_Websock_Config_GetAll') IS NOT NULL
    Drop procedure [dbo].A_Websock_Config_GetAll
GO

Create Procedure [dbo].A_Websock_Config_GetAll
as
Begin
  
    Select * 
    From .[dbo].A_Websock_Config
    
End
GO