﻿
if exists ( select * from sysobjects where id=object_id ( 'dbo.A_TaskManager_List_DistrDirectDb_SearchForCall' ))
	Drop procedure dbo.A_TaskManager_List_DistrDirectDb_SearchForCall
GO

Create procedure dbo.A_TaskManager_List_DistrDirectDb_SearchForCall
	@idoperator uniqueidentifier,
	@taskid uniqueidentifier,
	@cols nvarchar ( 1000 ),
	@idfield nvarchar ( 100 ) = 'Id',
	@table nvarchar ( 100 ) = '',
	@query nvarchar ( 4000 ) = '',
	@search nvarchar ( 4000 ) = '',
	@states nvarchar ( 4000 ) = '',
	@dtnow datetime = NULL,
	@partindex int = 0,
	@partcount int = 1000,
	@totalrowcount int OUTPUT
as
begin

----------------------------------------------------------------------
/*
declare @idoperator uniqueidentifier
select @idoperator = id from A_Users Where login like 'Peter'

declare @taskid uniqueidentifier
set @taskid = 'C5D4BCB0-3831-432E-A611-ACBBAD6FFACC'

declare @cols nvarchar ( 1000 )
set @cols = ', Nm'

declare @table nvarchar ( 100 )
set @table = 'dbo.t1'

declare @query nvarchar ( 1000 )
set @query = ''

declare @search nvarchar ( 1000 )
set @search = 'Nm like ''%П%'''

declare @states nvarchar ( 4000 )
set @states = '6:0,5:1,11:1,0:2'
*/
--------------------------------------------------------------------------

	if ( @dtnow is null )
		set @dtnow = GetDate()

	declare @operator nvarchar ( 100 )
	set @operator = '''' + cast ( @idoperator as nvarchar ( 100 ) ) + ''''

	declare @tableidx nvarchar ( 100 )
	set @tableidx = 'dbo.[A_TaskManager_dIdx_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tableidxn nvarchar ( 100 )
	set @tableidxn = 'dbo.[A_TaskManager_dIdxn_' + cast ( @taskid as nvarchar ( 50 ) ) + ']'

	declare @tmptable nvarchar ( 100 )
	set @tmptable = 'dbo.[t_cachex_' + cast ( NewId ( ) as nvarchar ( 100 ) ) + ']'

	declare @sql nvarchar ( 4000 )

	-----------------------------------------------

	declare @callstates table ( id int, type int )
	declare @i int, @j1 int, @j2 int, @st1 nvarchar ( 100 ), @vs int, @vt int
	set @i = 0
	set @j1 = 1
	set @j2 = 0
			
	set @j2 = charindex ( ',', @states, @j1 )
	while @j2 > 0 or @i = 0
	begin		
		if ( @j2 = 0 )
		begin
			set @j2 = len ( @states ) + 1
			set @i = 1
		end
	
		select @st1 = LTRIM ( RTRIM ( substring ( @states, @j1, @j2-@j1 ) ) )
		select @vs = Cast ( SubString ( @st1, 1, charindex ( ':', @st1, 1 ) - 1 ) as int )
		set @j1 = charindex ( ':', @st1, 1 ) + 1
		select @vt = Cast ( SubString ( @st1, @j1, len ( @st1 ) - @j1 + 1 ) as int )

		Insert into @callstates values ( @vs, @vt )

		select @j1 = @j2 + 1, @j2 = 0
		set @j2 = charindex ( ',', @states, @j1 )
	end
	

	----------------------------------------------

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t' ) )
		Drop table #t

	if exists ( Select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#t2' ) )
		Drop table #t2	
	
	Create table #t ( id int, Phone nvarchar ( 50 ) collate database_default )
	
	set @sql = '
		Select id2.Id, id2.Phone 
		From ' + @tableidx + ' id1 
			Inner join ' + @tableidxn + ' id2 on id1.Id = id2.Id
		Where IdOperator = ' + @operator + '
		'
	Insert into #t
		exec sp_executesql @sql



	declare @temp table ( IdInList int, AbonentNumber nvarchar ( 50 ) collate database_default, DTS DateTime  )

	Insert into @temp
		Select IdInList, AbonentNumber, Max ( DateTimeStart ) as DTS
		From #t t 
			inner join oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec on t.Id = ec.IdInList and t.Phone = ec.AbonentNumber
		Where IdTask = @taskid
		Group by IdInList, AbonentNumber


	Set @sql = 'Drop table ' + @tmptable
	if exists ( Select * FROM sysobjects where id = object_id ( @tmptable ) )
		exec sp_executesql @sql

	--Set @sql = 'Create table ' + @tmptable + ' ( Id int, '

	declare @ready table ( Id int )
	Insert into @ready
		Select IdInList
		From A_TaskManager_SubTasks
		Where TaskId = @taskid and NResult > 0

	--все несделанные из тронутых. Надо сделать, чтобы не фильтровались по состояниям. для этого
	if exists ( Select id from @callstates Where Type = 3 )
	begin
		Delete From @callstates where Type = 0 or Type = 1
		Insert into @callstates values ( 0, 10 )
	end
		

	
	--если по фильтрам смотреть надо - надо однако фильтрануть всех, кто уже сделан
	Select t.IdInList, t.AbonentNumber, ec.DateTimeStart as __DateTimeStart, ec.CallResult as __CallResult, ec.UserResult as __UserResult, oi.[Name] as __Operator, case when ( st.NextEffortTime > stn.NextEffortTime ) then st.NextEffortTime else stn.NextEffortTime end as __NextCallTime into #t2
	From @temp t
		inner join oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec on t.IdInList = ec.IdInList and t.AbonentNumber = ec.AbonentNumber and t.DTS = ec.DateTimeStart
		inner join @callstates cs on ( ec.CallResult = cs.Id and cs.Type = 0 ) or ( ec.UserResult = cs.Id and cs.Type = 1 ) or ( cs.Type = 10 )
		
		inner join A_TaskManager_SubTaskNumber stn on t.IdInList = stn.IdInList and t.AbonentNumber = stn.Number and stn.TaskId = @taskid
		inner join A_TaskManager_SubTasks st on t.IdInList = st.IdInList and st.TaskId = @taskid
		Left join oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo oi on ec.IdOperator = oi.[Id]
	Where not exists ( Select * FROM @ready where Id = t.IdInList )

	Alter table #t2 Alter Column __DateTimeStart DateTime NULL
	Alter table #t2 Alter Column __CallResult Int NULL
	Alter table #t2 Alter Column __UserResult Int NULL
	Alter table #t2 Alter Column __Operator nvarchar ( 100 ) NULL
	Alter table #t2 Alter Column __NextCallTime DateTime NULL

	Update #t2 set __NextCallTime = null where __NextCallTime < @dtnow

	--нетронутые (которых нет в кубе, и в статистике попыток задачи), нужны при выборе пунктов "нетронутые" и "несделанные"
	if exists ( Select id from @callstates Where Type = 2 or Type= 3 )
		Insert into #t2 ( IdInList, AbonentNumber )
		Select Id, Phone From #t t
			Where not exists ( Select IdInList From @temp where IdInList = t.Id and AbonentNumber = t.Phone )
				and not exists ( Select Id From @ready Where Id = t.Id )

	if ( Len ( @search ) > 0 )
	begin
		Set @sql = 'Select Count ( * ) From '
		if ( Len ( @table ) > 0 )
			Set @sql = @sql + @table + ' '
		else
			Set @sql = @sql + ' (' + @query + ') '
		Set @sql = @sql + ' t inner join #t2 t2 on t.[' + @idfield + '] = t2.IdInList Where ' + @search

		if exists ( Select * From tempdb..sysobjects where id = object_id ( 'tempdb..#t_smp' ) )
			drop table #t_smp

		create table #t_smp ( cnt int )
		Insert into #t_smp
			exec sp_executesql @sql

		Select @totalrowcount = cnt From #t_smp
	end
	else
		Select @totalrowcount = Count ( * ) From #t2

	declare @howmany int
	declare @topcnt int
	select @howmany = ( @partindex + 1 ) * @partcount - @totalrowcount, @topcnt = @partcount
	if ( @howmany > 0 )
		set @topcnt = @partcount - @howmany

	Set @sql = 'Select * From ( Select Top ' + Cast ( @topcnt as nvarchar ( 10 ) ) + ' * From ( '
	Set @sql = @sql + ' Select Top ' + Cast ( ( @partindex + 1 ) * @partcount as nvarchar ( 10 ) ) + ' t2.* ' + @cols + ' From '
	if ( Len ( @table ) > 0 )
		Set @sql = @sql + @table + ' '
	else
		Set @sql = @sql + ' (' + @query + ') '
	Set @sql = @sql + ' t inner join #t2 t2 on t.[' + @idfield + '] = t2.IdInList '
	if ( Len ( @search ) > 0 )
		Set @sql = @sql + 'Where ' + @search
	Set @sql = @sql + ' Order by IdInList ) tp Order By IdInList desc ) a Order by IdInList'

	exec sp_executesql @sql	

end
GO
