﻿
---------------------------------------------------------------------------------
If exists ( Select * From oktell_settings.dbo.sysobjects where id = object_id ( 'oktell_settings.dbo.A_UserParams' ))
  If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_UserParams' 
								and TABLE_CATALOG like 'oktell_settings'
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME in ('SkillTags') )
	Alter Table [oktell_settings].[dbo].[A_UserParams]
	Add
		[SkillTags] nvarchar(4000) default ''		
GO

Update [oktell_settings].[dbo].[A_UserParams] 
Set [SkillTags] = ''
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserParams' ))
	Drop view dbo.A_UserParams
GO

Create view dbo.A_UserParams
as
	Select * 
	From oktell_settings.dbo.A_UserParams
GO

---------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_GetAllOperators' ))
	Drop procedure dbo.A_CallCenter_GetAllOperators
GO

Create Procedure [dbo].[A_CallCenter_GetAllOperators]
As
begin
	-- obsolete
	
	Select u.id as uid, u.name as uname, up.SkillTags as uskilltags, NULL as gid, NULL as gcaption
	From
		A_Users u inner join 
		A_UserParams up on u.id = up.iduser		
	Where ( up.IsOperator > 0 ) and 
		(( u.IsDeleted = 0 ) or ( u.IsDeleted is null ))
		
end
GO


---------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Operator_Save' ))
	Drop procedure dbo.A_CallCenter_Operator_Save
GO

Create Procedure [dbo].A_CallCenter_Operator_Save
	@iduser uniqueidentifier,
	@skilltags nvarchar(4000) = ''
As
begin
	
	Update dbo.A_UserParams
	Set SkillTags = @skilltags
	Where (IdUser = @iduser)
		and ( IsOperator > 0 )
		/*(( u.IsDeleted = 0 ) or ( u.IsDeleted is null ))*/
		
end
GO

