﻿IF OBJECT_ID ('dbo.A_DB_UpdateOwnerUser') IS NOT NULL
    DROP  procedure dbo.A_DB_UpdateOwnerUser
GO

CREATE procedure dbo.A_DB_UpdateOwnerUser
as
begin 

        Declare @oktelldb nvarchar(50), @oktellccdb nvarchar(50), @oktellsettingsdb nvarchar(50)
        Select @oktelldb = 'oktell', 
                @oktellccdb = 'oktell_cc_temp', 
                @oktellsettingsdb = 'oktell_settings'
        
        Declare @Statement nvarchar(4000),
            @set_owner nvarchar(4000),
            @user_name nvarchar(50) 
        
        Set @user_name = SYSTEM_USER
        
        Set @set_owner = N'    
                IF NOT EXISTS (select 1 from master..sysdatabases WHERE name = @db_name AND suser_sname(sid) = N''' + @user_name + '''  )
                BEGIN                               
                    IF EXISTS(SELECT 1 FROM sysusers WHERE suser_sname(sid) = N''' + @user_name + ''' AND [name] != ''dbo'')
                    BEGIN
                        SET @sql_sql = ''''
                        SELECT @sql_sql = @sql_sql + N''   REVOKE ALL TO '' + su.[name] + N''
                        EXEC sp_droprolemember ''''db_owner'''' , '''''' + su.[name] + ''''''
                        EXEC SP_DROPUSER '' + su.[name]  
                            FROM sysusers su 
                            WHERE suser_sname(su.sid) = N''' + @user_name + ''' AND su.[name] != ''dbo''
                        
                        EXEC sp_executesql @sql_sql 
                    END
                    
                    EXEC sp_changedbowner @loginame = N''' + @user_name + ''', @map = false
                END
                '
                
        Set @Statement = N'
            DECLARE @db_name nvarchar(50),
                @curr_user nvarchar(50),
                @sql_sql nvarchar(4000)
            
            USE ' + @oktelldb  + N'
            Set @curr_user = CURRENT_USER
            SET @db_name = ''' +@oktelldb + ''' ' + @set_owner + N'
            
            USE ' + @oktellccdb  +  N'
            Set @curr_user = CURRENT_USER
            SET @db_name = ''' +@oktellccdb + ''' ' + @set_owner + N'
             
            USE ' + @oktellsettingsdb  +  N'
            Set @curr_user = CURRENT_USER
            SET @db_name = ''' +@oktellsettingsdb + ''' ' + @set_owner

        ----- Проверка прав на возможность выполнения процедуры
        IF (SELECT IS_SRVROLEMEMBER('sysadmin')) = 1
            Exec sp_executesql @Statement 
        
        RETURN
end
GO