﻿
-----------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Settings_UpdateDbVersion'))
	Drop procedure dbo.A_Settings_UpdateDbVersion
GO

Create procedure dbo.A_Settings_UpdateDbVersion
	@dtnewversion datetime
as
begin

	Update dbo.A_Settings
	Set valueDateTime = @dtnewversion
	Where name like 'DBVersion'
	
	if ( @@rowcount = 0 )
		Insert 
		Into dbo.A_Settings ( [Name], ValueDateTime ) 
		Values ( 'DBVersion', @dtnewversion ) 
	
end
GO